=== test/manual/CMakeLists.txt ===
add_ledger_harness_tests(Manual)
