=== debian/changelog ===
ledger (3.4.0-1) unstable; urgency=medium

  * Update to new upstream version 3.4.0.
  * Bug fix: "FTBFS with CMake 4", thanks to roehling@debian.org</a>;
    (Closes: #1113098).

 -- David Bremner <bremner@debian.org>  Thu, 23 Oct 2025 08:34:28 -0300
