=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/ledger-$1\.tar\.gz/ \
  https://github.com/ledger/ledger/tags .*/v?(\d\S*)\.tar\.gz
